<template>
  <div class="pdf-container grey lighten-3">
    <div v-if="pdfData" class="pdf-container">
      <object :data="pdfData" type="application/pdf" width="100%" height="600px" class="pdf-embed">
        <embed :src="pdfData" type="application/pdf" class="pdf-embed" />
      </object>
    </div>
    <v-layout
      v-else
      align-center
      justify-center
      fill-height
      class="pdf-embed"
    >
      <v-flex xs-12>
        <v-icon size="96" class="mb-5">textsms</v-icon><br />
        Rozpocznij wypełnianie formularza, aby zobaczyć podgląd.
      </v-flex>
    </v-layout>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';
import PdfGenerator from './PdfGenerator';

const pdf = new PdfGenerator();

export default {
  methods: {
    async renderPdf() {
      const generatedFlags = [];
      // Create new pdf document and await for download third-party fonts
      await pdf.newDocument();

      // Generate document content
      this.pdfSections.forEach((section) => {
        generatedFlags.push(pdf.generateSection(section.name, section.data));
      });

      const shouldGenerate = generatedFlags.some(flag => flag === true);

      // End pdf document
      pdf.endDocument();

      if (shouldGenerate) {
        // Await for generating blob
        this.setPdfData(await pdf.getBlob());
      }
    },
    ...mapActions('pdf', ['setPdfData']),
  },
  computed: {
    pdfSections() {
      const formData = this.allFormData;

      return [
        {
          name: 'dateAndPlace',
          data: {
            documentCity: formData.others.documentCity,
            documentDate: formData.others.documentDate,
          },
        },
        {
          name: 'employee',
          data: formData.employee,
        },
        {
          name: 'employer',
          data: formData.employer,
        },
        {
          name: 'heading',
          data: {
            agreementType: formData.others.agreementType,
          },
        },
        {
          name: 'content',
          data: {
            agreementDate: formData.others.agreementDate,
            companyName: formData.employer.name,
            fullName: formData.others.fullName,
          },
        },
      ];
    },
    ...mapGetters('pdf', { pdfData: 'getPdfData' }),
    ...mapGetters('form', { allFormData: 'getAllFormData' }),
  },
  watch: {
    allFormData: {
      handler() {
        this.renderPdf();
      },
      deep: true,
    },
  },
};
</script>

<style scoped>
  .pdf-container {
    position: relative;
    width: 100%;
    height: 0;
    padding-bottom: 139.16%;
  }
  .pdf-embed {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
</style>
